【POJ1733】Parity game

【POJ1733】Parity game

题面

vjudge

题解

比较简单的分类并查集
将一个查询操作看作前缀和\(s_r-s_{l-1}\)的奇偶性
将每个点拆成一奇一偶然后分别连边即可
如果一个点的奇点和偶点被连在一起了就判无解即可
代码

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <climits>
using namespace std;

inline int gi() {
    register int data = 0, w = 1;
    register char ch = 0;
    while (ch != '-' && (ch > '9' || ch < '0')) ch = getchar();
    if (ch == '-') w = -1 , ch = getchar();
    while (ch >= '0' && ch <= '9') data = data * 10 + (ch ^ 48), ch = getchar();
    return w * data;
}
const int MAX_N = 5005;
int M, N, l[MAX_N], r[MAX_N], X[MAX_N << 1], cnt;
int fa[MAX_N << 1];
int getf(int x) { return (x == fa[x]) ? x : (x = getf(fa[x])); }
void unite(int x, int y) { fa[getf(x)] = getf(y); }
bool same(int x, int y) { return getf(x) == getf(y); }
char ch[MAX_N][10];
int main () {
    M = gi(), N = gi();
    for (int i = 1; i <= N; i++) {
        l[i] = gi() - 1, r[i] = gi();
        X[++cnt] = l[i], X[++cnt] = r[i];
        scanf("%s", ch[i]);
    }
    sort(&X[1], &X[cnt + 1]); cnt = unique(&X[1], &X[cnt + 1]) - X - 1;
    for (int i = 1; i <= N; i++) {
        l[i] = lower_bound(&X[1], &X[cnt + 1], l[i]) - X;
        r[i] = lower_bound(&X[1], &X[cnt + 1], r[i]) - X;
    }
    for (int i = 1; i <= N * 2; i++) fa[i] = i;
    for (int i = 1; i <= N; i++) {
        char op = ch[i][0]; int x = l[i], y = r[i];
        if (op == 'e') {
            unite(x, y); unite(x + N, y + N);
            if (same(x + N, x) || same(y, y + N)) return printf("%d\n", i - 1) & 0;
        } else {
            unite(x, y + N); unite(x + N, y);
            if (same(x + N, x) || same(y, y + N)) return printf("%d\n", i - 1) & 0;
        }
    }
    printf("%d\n", N);
    return 0;
} 

原文地址:https://www.cnblogs.com/heyujun/p/10140211.html

时间: 2024-11-08 17:23:56

【POJ1733】Parity game的相关文章

【poj1733】 Parity game

http://poj.org/problem?id=1733 (题目链接) 题意 一个由0,1组成的序列,每次给出一段区间的奇偶,问哪一条信息不合法. Solution 并查集. 题目中序列的长度有很大,单纯搜索一定会TLE. 我们用s[i]表示前i个数的前缀和,那么a b even意味着s[b]和s[a-1]的奇偶性相同.a b odd意味着s[b]与s[a-1]的奇偶性不同.于是我们根据奇偶性的不同,用并查集依次处理他们之间的关系.当某条信息出现与并查集中记录的信息不符合时,则此信息不合法.

【POJ1733】【带标记并查集】Parity game

Description Now and then you play the following game with your friend. Your friend writes down a sequence consisting of zeroes and ones. You choose a continuous subsequence (for example the subsequence from the third to the fifth digit inclusively) a

【UVA】11464-Even Parity(二进制枚举子集)

枚举第一行的所有可能情况,之后根据上面行计算下面行(判断是否冲突),获得最终结果. 14058243 11464 Even Parity Accepted C++ 0.275 2014-08-18 05:14:15 #include<cstdio> #include<cstring> #include<iostream> #include<algorithm> #include<vector> #include<stack> #inc

【leetcode】905. Sort Array By Parity

题目如下: 解题思路:本题和[leetcode]75. Sort Colors类似,但是没有要求在输入数组本身修改,所以难度降低了.引入一个新的数组,然后遍历输入数组,如果数组元素是是偶数,插入到新数组头部,否则追加到尾部. 代码如下: class Solution(object): def sortArrayByParity(self, A): """ :type A: List[int] :rtype: List[int] """ res =

【Codeforces Global Round 1 A】Parity

[链接] 我是链接,点我呀:) [题意] 给你一个k位数b进制的进制转换. 让你求出来转成10进制之后这个数字是奇数还是偶数 [题解] 模拟一下转换的过程,加乘的时候都记得对2取余就好 [代码] import java.io.*; import java.util.*; public class Main { static int N = (int)1e5; static InputReader in; static PrintWriter out; static int b,k; static

【HDOJ图论题集】【转】

1 =============================以下是最小生成树+并查集====================================== 2 [HDU] 3 1213 How Many Tables 基础并查集★ 4 1272 小希的迷宫 基础并查集★ 5 1325&&poj1308 Is It A Tree? 基础并查集★ 6 1856 More is better 基础并查集★ 7 1102 Constructing Roads 基础最小生成树★ 8 1232

【笔记】SerialPort类的实现

class CSerialPort { public: // contruction and destruction CSerialPort(); virtual ~CSerialPort(); // port initialisation BOOL InitPort(CWnd* pPortOwner, UINT portnr = 1, UINT baud = 19200, char parity = 'N', UINT databits = 8, UINT stopsbits = 1, DWO

【转载】使用Win32API实现Windows下异步串口通讯

一,异步非阻塞串口通讯的优点 读写串行口时,既可以同步执行,也可以重叠(异步)执行.在同步执行时,函数直到操作完成后才返回.这意味着在同步执行时线程会被阻塞,从而导致效率下降.在重叠执行时,即使操作还未完成,调用的函数也会立即返回.费时的I/O操作在后台进行,这样线程就可以干别的事情.例如,线程可以在不同的句柄上同时执行I/O操作,甚至可以在同一句柄上同时进行读写操作."重叠"一词的含义就在于此. 二,异步非阻塞串口通讯的基本原理首先,确定要打开的串口名.波特率.奇偶校验方式.数据位.

【uva10057】巧妙做法

这个题之前做过,方法太笨还不对,今天再做突然想到一个巧妙做法,网上应该也有别人用此方法的,因为并不是很难,但我没有看别人的,是自己想出来的哈哈哈 首先要对输入的数组进行排序,这是毋庸置疑的. 因为要计算绝对值的和,所以就想到了数轴上的距离的概念.要使|X1-A|+|X2-A|最小,也就是要找一个点A,使其到X1,X2距离和最短,所以很容易想到在数轴上只要A在X1和X2之间就行. 对排序后的数组进行操作,将首尾(最小值和最大值)抽取出来,A只要介于他俩之间就行,同理再将第二位和倒数第二位抽取出来,